diff --git a/rsvg-styles.c b/rsvg-styles.c
index 0e6095c..6836894 100644
--- a/rsvg-styles.c
+++ b/rsvg-styles.c
@@ -1,4 +1,5 @@
-/* vim: set sw=4 sts=4: -*- Mode: C; tab-width: 4; indent-tabs-mode: t; c-basic-offset: 4 -*- */
+/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
+/* vim: set sw=4 sts=4 ts=4 expandtab: */
 /*
    rsvg-styles.c: Handle SVG styles
 
@@ -22,6 +23,8 @@
 
    Author: Raph Levien <raph@artofcode.com>
 */
+#include "config.h"
+
 #include <string.h>
 #include <math.h>
 
@@ -34,8 +37,65 @@
 #include "rsvg-mask.h"
 #include "rsvg-marker.h"
 
+#include <libcroco/libcroco.h>
+
 #define RSVG_DEFAULT_FONT "Times New Roman"
 
+enum {
+  SHAPE_RENDERING_AUTO = CAIRO_ANTIALIAS_DEFAULT,
+  SHAPE_RENDERING_OPTIMIZE_SPEED = CAIRO_ANTIALIAS_NONE,
+  SHAPE_RENDERING_CRISP_EDGES = CAIRO_ANTIALIAS_NONE,
+  SHAPE_RENDERING_GEOMETRIC_PRECISION = CAIRO_ANTIALIAS_DEFAULT
+};
+
+enum {
+  TEXT_RENDERING_AUTO = CAIRO_ANTIALIAS_DEFAULT,
+  TEXT_RENDERING_OPTIMIZE_SPEED = CAIRO_ANTIALIAS_NONE,
+  TEXT_RENDERING_OPTIMIZE_LEGIBILITY = CAIRO_ANTIALIAS_DEFAULT,
+  TEXT_RENDERING_GEOMETRIC_PRECISION = CAIRO_ANTIALIAS_DEFAULT
+};
+
+typedef struct _StyleValueData {
+    gchar *value;
+    gboolean important;
+} StyleValueData;
+
+/*
+ * _rsvg_cairo_matrix_init_shear: Set up a shearing matrix.
+ * @dst: Where to store the resulting affine transform.
+ * @theta: Shear angle in degrees.
+ *
+ * Sets up a shearing matrix. In the standard libart coordinate system
+ * and a small value for theta, || becomes \\. Horizontal lines remain
+ * unchanged.
+ **/
+static void
+_rsvg_cairo_matrix_init_shear (cairo_matrix_t *dst, double theta)
+{
+  cairo_matrix_init (dst, 1., 0., tan (theta * M_PI / 180.0), 1., 0., 0);
+}
+
+static StyleValueData *
+style_value_data_new (const gchar *value, gboolean important)
+{
+    StyleValueData *ret;
+
+    ret = g_new (StyleValueData, 1);
+    ret->value = g_strdup (value);
+    ret->important = important;
+
+    return ret;
+}
+
+static void
+style_value_data_free (StyleValueData *value)
+{
+    if (!value)
+        return;
+    g_free (value->value);
+    g_free (value);
+}
+
 gdouble
 rsvg_viewport_percentage (gdouble width, gdouble height)
 {
@@ -53,23 +113,28 @@ rsvg_state_init (RsvgState * state)
 {
     memset (state, 0, sizeof (RsvgState));
 
-    _rsvg_affine_identity (state->affine);
-    _rsvg_affine_identity (state->personal_affine);
+    state->parent = NULL;
+    cairo_matrix_init_identity (&state->affine);
+    cairo_matrix_init_identity (&state->personal_affine);
     state->mask = NULL;
     state->opacity = 0xff;
-    state->adobe_blend = 0;
-    state->fill = rsvg_paint_server_parse (NULL, NULL, "#000", 0);
+    state->baseline_shift = 0.;
+    state->current_color = 0xff000000; /* See bgo#764808; we don't inherit CSS
+                                        * from the public API, so start off with
+                                        * opaque black instead of transparent.
+                                        */
+    state->fill = rsvg_paint_server_parse (NULL, "#000");
     state->fill_opacity = 0xff;
     state->stroke_opacity = 0xff;
     state->stroke_width = _rsvg_css_parse_length ("1");
     state->miter_limit = 4;
-    state->cap = RSVG_PATH_STROKE_CAP_BUTT;
-    state->join = RSVG_PATH_STROKE_JOIN_MITER;
+    state->cap = CAIRO_LINE_CAP_BUTT;
+    state->join = CAIRO_LINE_JOIN_MITER;
     state->stop_opacity = 0xff;
-    state->fill_rule = FILL_RULE_NONZERO;
-    state->clip_rule = FILL_RULE_NONZERO;
+    state->fill_rule = CAIRO_FILL_RULE_WINDING;
+    state->clip_rule = CAIRO_FILL_RULE_WINDING;
     state->enable_background = RSVG_ENABLE_BACKGROUND_ACCUMULATE;
-    state->comp_op = RSVG_COMP_OP_SRC_OVER;
+    state->comp_op = CAIRO_OPERATOR_OVER;
     state->overflow = FALSE;
     state->flood_color = 0;
     state->flood_opacity = 255;
@@ -81,17 +146,19 @@ rsvg_state_init (RsvgState * state)
     state->font_weight = PANGO_WEIGHT_NORMAL;
     state->font_stretch = PANGO_STRETCH_NORMAL;
     state->text_dir = PANGO_DIRECTION_LTR;
+    state->text_gravity = PANGO_GRAVITY_SOUTH;
     state->unicode_bidi = UNICODE_BIDI_NORMAL;
     state->text_anchor = TEXT_ANCHOR_START;
     state->letter_spacing = _rsvg_css_parse_length ("0.0");
     state->visible = TRUE;
     state->cond_true = TRUE;
     state->filter = NULL;
-    state->clip_path_ref = NULL;
+    state->clip_path = NULL;
     state->startMarker = NULL;
     state->middleMarker = NULL;
     state->endMarker = NULL;
 
+    state->has_baseline_shift = FALSE;
     state->has_current_color = FALSE;
     state->has_flood_color = FALSE;
     state->has_flood_opacity = FALSE;
@@ -120,6 +187,7 @@ rsvg_state_init (RsvgState * state)
     state->has_font_stretch = FALSE;
     state->has_font_decor = FALSE;
     state->has_text_dir = FALSE;
+    state->has_text_gravity = FALSE;
     state->has_unicode_bidi = FALSE;
     state->has_text_anchor = FALSE;
     state->has_letter_spacing = FALSE;
@@ -128,10 +196,22 @@ rsvg_state_init (RsvgState * state)
     state->has_endMarker = FALSE;
     state->has_overflow = FALSE;
 
-	state->shape_rendering_type = SHAPE_RENDERING_AUTO;
-	state->has_shape_rendering_type = FALSE;
-	state->text_rendering_type = TEXT_RENDERING_AUTO;
-	state->has_text_rendering_type = FALSE;
+    state->shape_rendering_type = SHAPE_RENDERING_AUTO;
+    state->has_shape_rendering_type = FALSE;
+    state->text_rendering_type = TEXT_RENDERING_AUTO;
+    state->has_text_rendering_type = FALSE;
+
+    state->styles = g_hash_table_new_full (g_str_hash, g_str_equal,
+                                           g_free, (GDestroyNotify) style_value_data_free);
+}
+
+void
+rsvg_state_reinit (RsvgState * state)
+{
+    RsvgState *parent = state->parent;
+    rsvg_state_finalize (state);
+    rsvg_state_init (state);
+    state->parent = parent;
 }
 
 typedef int (*InheritanceFunction) (int dst, int src);
@@ -140,15 +220,25 @@ void
 rsvg_state_clone (RsvgState * dst, const RsvgState * src)
 {
     gint i;
+    RsvgState *parent = dst->parent;
 
     rsvg_state_finalize (dst);
 
     *dst = *src;
+    dst->parent = parent;
+    dst->filter = g_strdup (src->filter);
+    dst->mask = g_strdup (src->mask);
+    dst->clip_path = g_strdup (src->clip_path);
     dst->font_family = g_strdup (src->font_family);
     dst->lang = g_strdup (src->lang);
+    dst->startMarker = g_strdup (src->startMarker);
+    dst->middleMarker = g_strdup (src->middleMarker);
+    dst->endMarker = g_strdup (src->endMarker);
     rsvg_paint_server_ref (dst->fill);
     rsvg_paint_server_ref (dst->stroke);
 
+    dst->styles = g_hash_table_ref (src->styles);
+
     if (src->dash.n_dash > 0) {
         dst->dash.dash = g_new (gdouble, src->dash.n_dash);
         for (i = 0; i < src->dash.n_dash; i++)
@@ -169,6 +259,8 @@ rsvg_state_inherit_run (RsvgState * dst, const RsvgState * src,
 {
     gint i;
 
+    if (function (dst->has_baseline_shift, src->has_baseline_shift))
+        dst->baseline_shift = src->baseline_shift;
     if (function (dst->has_current_color, src->has_current_color))
         dst->current_color = src->current_color;
     if (function (dst->has_flood_color, src->has_flood_color))
@@ -225,33 +317,41 @@ rsvg_state_inherit_run (RsvgState * dst, const RsvgState * src,
         dst->font_decor = src->font_decor;
     if (function (dst->has_text_dir, src->has_text_dir))
         dst->text_dir = src->text_dir;
+    if (function (dst->has_text_gravity, src->has_text_gravity))
+        dst->text_gravity = src->text_gravity;
     if (function (dst->has_unicode_bidi, src->has_unicode_bidi))
         dst->unicode_bidi = src->unicode_bidi;
     if (function (dst->has_text_anchor, src->has_text_anchor))
         dst->text_anchor = src->text_anchor;
     if (function (dst->has_letter_spacing, src->has_letter_spacing))
-	dst->letter_spacing = src->letter_spacing;
-    if (function (dst->has_startMarker, src->has_startMarker))
-        dst->startMarker = src->startMarker;
-    if (function (dst->has_middleMarker, src->has_middleMarker))
-        dst->middleMarker = src->middleMarker;
-    if (function (dst->has_endMarker, src->has_endMarker))
-        dst->endMarker = src->endMarker;
-	if (function (dst->has_shape_rendering_type, src->has_shape_rendering_type))
-		dst->shape_rendering_type = src->shape_rendering_type;
-	if (function (dst->has_text_rendering_type, src->has_text_rendering_type))
-		dst->text_rendering_type = src->text_rendering_type;
+        dst->letter_spacing = src->letter_spacing;
+    if (function (dst->has_startMarker, src->has_startMarker)) {
+        g_free (dst->startMarker);
+        dst->startMarker = g_strdup (src->startMarker);
+    }
+    if (function (dst->has_middleMarker, src->has_middleMarker)) {
+        g_free (dst->middleMarker);
+        dst->middleMarker = g_strdup (src->middleMarker);
+    }
+    if (function (dst->has_endMarker, src->has_endMarker)) {
+        g_free (dst->endMarker);
+        dst->endMarker = g_strdup (src->endMarker);
+    }
+    if (function (dst->has_shape_rendering_type, src->has_shape_rendering_type))
+            dst->shape_rendering_type = src->shape_rendering_type;
+    if (function (dst->has_text_rendering_type, src->has_text_rendering_type))
+            dst->text_rendering_type = src->text_rendering_type;
 
     if (function (dst->has_font_family, src->has_font_family)) {
         g_free (dst->font_family);      /* font_family is always set to something */
         dst->font_family = g_strdup (src->font_family);
     }
 
-	if (function (dst->has_space_preserve, src->has_space_preserve))
-		dst->space_preserve = src->space_preserve;
+    if (function (dst->has_space_preserve, src->has_space_preserve))
+        dst->space_preserve = src->space_preserve;
 
-	if (function (dst->has_visible, src->has_visible))
-		dst->visible = src->visible;
+    if (function (dst->has_visible, src->has_visible))
+        dst->visible = src->visible;
 
     if (function (dst->has_lang, src->has_lang)) {
         if (dst->has_lang)
@@ -274,12 +374,14 @@ rsvg_state_inherit_run (RsvgState * dst, const RsvgState * src,
     }
 
     if (inherituninheritables) {
-        dst->clip_path_ref = src->clip_path_ref;
-        dst->mask = src->mask;
+        g_free (dst->clip_path);
+        dst->clip_path = g_strdup (src->clip_path);
+        g_free (dst->mask);
+        dst->mask = g_strdup (src->mask);
+        g_free (dst->filter);
+        dst->filter = g_strdup (src->filter);
         dst->enable_background = src->enable_background;
-        dst->adobe_blend = src->adobe_blend;
         dst->opacity = src->opacity;
-        dst->filter = src->filter;
         dst->comp_op = src->comp_op;
     }
 }
